Index: /DCWoRMS/trunk/src/simulator/DCWormsUsers.java
===================================================================
--- /DCWoRMS/trunk/src/simulator/DCWormsUsers.java	(revision 481)
+++ /DCWoRMS/trunk/src/simulator/DCWormsUsers.java	(revision 481)
@@ -0,0 +1,329 @@
+package simulator;
+
+import eduni.simjava.Sim_event;
+import eduni.simjava.Sim_system;
+import gridsim.GridSim;
+import gridsim.GridSimTags;
+import gridsim.Gridlet;
+import gridsim.IO_data;
+import gridsim.gssim.DCWormsTags;
+import gridsim.net.InfoPacket;
+import gssim.schedframe.scheduling.utils.JobDescription;
+import gssim.schedframe.scheduling.utils.TaskDescription;
+
+import java.util.ArrayList;
+import java.util.HashSet;
+import java.util.Iterator;
+import java.util.List;
+import java.util.Map;
+import java.util.Set;
+import java.util.TreeMap;
+
+import org.apache.commons.logging.Log;
+import org.apache.commons.logging.LogFactory;
+import org.joda.time.DateTime;
+
+import qcg.shared.constants.BrokerConstants;
+import schedframe.scheduling.tasks.Job;
+import schedframe.scheduling.tasks.JobInterface;
+import schedframe.scheduling.tasks.Task;
+import schedframe.scheduling.tasks.TaskInterface;
+import simulator.utils.XsltTransformations;
+import simulator.workload.WorkloadLoader;
+
+public class DCWormsUsers extends GridSim implements GenericUser {
+
+	/**A job generator, which produces jobs and tasks. These jobs are then sent by this entity */
+	protected WorkloadLoader workloadLoader;
+	
+	/** The name of the entity, to which the created tasks will be sent */
+	protected String destName;
+	
+	/** Indicates, that all tasks that returned to this object are finished */
+	protected boolean allTasksAreFinished;
+	
+	/** Stores the list of jobs, that have been returned to this object */
+	protected List<JobInterface<?>> returnedJobs;
+	protected Set<String> sendJobsIds;
+	protected Set<String> returnedJobsIds;
+	
+	protected XsltTransformations xsltTransformer;
+	
+	/**
+	 * Indicates, that an error has occurred - it is used for debug purposes
+	 */
+	protected boolean error;
+	
+	private static Log log = LogFactory.getLog(DCWormsUsers.class);
+	
+	/**
+	 * Constructs the users object with the given parameters
+	 * @param name the name of the users entity (must be unique across all entities in the whole simulation)
+	 * @param destinationName the name of the entity, to which the created tasks will be sent 
+	 * @param jobGenerator the job generator, which produces jobs and tasks, that will be sent by this class
+	 * @throws Exception if any occurs (see {@link GridSim#GridSim(String, double)})
+	 */
+	public DCWormsUsers(String name, String destinationName, WorkloadLoader workload) throws Exception {
+		super(name, DCWormsConstants.DEFAULT_BAUD_RATE);
+		this.workloadLoader = workload;
+		destName = destinationName;
+		allTasksAreFinished = true;
+		error = false;
+		
+		sendJobsIds = new HashSet<String>();
+		returnedJobsIds = new HashSet<String>();
+		
+		this.xsltTransformer = new XsltTransformations();
+	}
+
+	@Override
+	public void body() {
+		sendJobs();
+		collectJobs();
+
+		//GridSim dependent code for shutting down the simulation
+		shutdownGridStatisticsEntity();
+		terminateIOEntities();
+		shutdownUserEntity();
+	}
+
+	/**
+	 * Collects the jobs sent to broker(s)
+	 */
+	protected void collectJobs() {
+		final int FACTOR = Math.min(10, workloadLoader.getTaskCount()); //the refresh rate of the gauge: at most 10 times
+		final int denominator = workloadLoader.getTaskCount() / FACTOR;
+		allTasksAreFinished = true;
+		returnedJobs = new ArrayList<JobInterface<?>>();
+		int counter = 0;
+		int oldRemeinder = 0;
+		boolean hundredPercent = false;
+		
+		Sim_event ev = new Sim_event();
+		sim_get_next(ev);
+		while (Sim_system.running()) {
+			switch (ev.get_tag()) {
+			case GridSimTags.END_OF_SIMULATION:
+				//no action
+				break;
+			
+			case GridSimTags.INFOPKT_SUBMIT:
+				processPingRequest(ev);
+				break;
+				
+			case GridSimTags.GRIDLET_RETURN:
+				JobInterface<?> returnedJob = (JobInterface<?>) ev.get_data();
+				
+				String jobId = returnedJob.getId();
+
+				
+				if (returnedJobs.contains(returnedJob)) {
+					if(log.isErrorEnabled())
+						log.error("Received the same job twice (job ID " + jobId + ")");
+					error = true;
+					break;
+				} 
+				
+				returnedJobs.add(returnedJob);
+				returnedJobsIds.add(jobId);
+				
+				if(returnedJob.getStatus() == BrokerConstants.JOB_STATUS_FINISHED) {
+					if(log.isDebugEnabled())
+						log.debug("Received finished job " + jobId);
+					
+				} else {
+					if(returnedJob.getStatus() == BrokerConstants.JOB_STATUS_CANCELED) {
+						if(log.isWarnEnabled()){
+							String str = "Warning! An uncomplished job (Job ID: "+jobId+") has returned to users. Job was canceled.";
+							log.warn(str);
+						}
+					}
+					
+					allTasksAreFinished = false;
+				}
+				
+				counter += returnedJob.getTaskCount();
+				int remainder = (counter / denominator);
+				if (remainder != oldRemeinder) {
+					int gauge = ((counter * 100) / (workloadLoader.getTaskCount()));
+					if(log.isInfoEnabled())
+						log.info(gauge + "% ");
+					
+					oldRemeinder = remainder;
+					if (gauge == 100)
+						hundredPercent = true;
+				}
+			
+				break;
+			} 
+			
+			//if all the Gridlets have been collected
+			if (counter == workloadLoader.getTaskCount()) {
+				break;
+			}
+			
+			sim_get_next(ev);
+		}
+		
+		//if all the Gridlets have been collected
+		if (counter == workloadLoader.getTaskCount()) {
+			if (! hundredPercent) {
+				if(log.isInfoEnabled())
+					log.info("100%");
+			}
+			if(log.isInfoEnabled())
+				log.info(get_name() + ": Received all "+workloadLoader.getJobCount()+" jobs and " + counter + " tasks");			
+		} else {
+			if(log.isErrorEnabled())
+				log.error(get_name() + ": ERROR DID NOT RECEIVED all tasks - some tasks were not finished! (received "+counter+" of "+workloadLoader.getTaskCount()+")");
+		}
+		
+		Iterator <String> itr = sendJobsIds.iterator();
+		String jobId;
+		if(log.isInfoEnabled()){
+			log.info("Missing tasks: ");
+			while(itr.hasNext()){
+				jobId = itr.next();
+				if(!returnedJobsIds.contains(jobId)){
+					log.info(jobId + ", ");
+				}
+			}
+		}
+		
+	}
+
+	/**
+	 * Sends jobs to broker entities
+	 */
+	protected void sendJobs() {
+		
+		Map<Long, List<Job>> jobTimes = new TreeMap<Long, List<Job>>();
+		int destID = GridSim.getEntityId(destName);
+		//destID=GridSim.getEntityId("BROKER@COMPUTING_GRID_0");
+		List<JobDescription> jobs = workloadLoader.getJobs();
+		//TaskRequirements taskReq = new TaskRequirementsImpl();
+		//double values[] = null;
+
+		for (JobDescription job : jobs) {
+			long l_submissionTime = Long.MAX_VALUE;
+			//pick the lowest submission time
+			for (TaskDescription task : job) {
+				if (task.getSubmissionTime() < l_submissionTime)
+					l_submissionTime = task.getSubmissionTime();
+			}
+
+			//store the submission time expressed in seconds after the simulation start time
+			long submissionTime = l_submissionTime;
+			
+			Job newJob = prepareJob(job, submissionTime);
+			
+			List<Job> list = jobTimes.get(submissionTime);
+			if (list == null) {
+				list = new ArrayList<Job>();
+				jobTimes.put(submissionTime, list);
+			}
+			list.add(newJob);
+		}
+		for (Long submissionTime : jobTimes.keySet()) {
+			List<Job> list = jobTimes.get(submissionTime);
+			for(int i = 0; i < list.size(); i++){
+				this.sendJobsIds.add(list.get(i).getId());
+				send(destID, submissionTime, GridSimTags.GRIDLET_SUBMIT, list.get(i));
+			}
+			
+			//send(output, submissionTime, GridSimTags.GRIDLET_SUBMIT, new IO_data(list, GssConstants.DEFAULT_GRIDLET_SIZE, destID));
+			//send(destID, submissionTime, GridSimTags.GRIDLET_SUBMIT, list);
+			
+		}
+		System.out.println("finished sending jobs");
+	}
+	
+	public List<JobDescription> getAllSentJobs() {
+		return (List<JobDescription>) workloadLoader.getJobs();
+	}
+	
+	public List<TaskDescription> getAllSentTasks() {
+		List<TaskDescription> result = new ArrayList<TaskDescription>();
+		List<JobDescription> sentJobs = getAllSentJobs();
+		for (JobDescription job : sentJobs) {
+			result.addAll(job);
+		}
+		return result;
+	}
+	
+	public List<JobInterface<?>> getAllReceivedJobs() {
+		return returnedJobs;
+	}
+
+	public int getFinishedTasksCount() {
+		int result = 0;
+		for (JobInterface<?> job : returnedJobs) {
+			for (TaskInterface<?> task: job.getTask()) {
+				if(task.getStatus() == DCWormsTags.SUCCESS)
+					result++;
+			}
+		}
+		return result;
+	}
+	
+	public String getUserName() {
+		return get_name();
+	}
+	
+	public boolean isError() {
+		return error;
+	}
+	
+	/**
+	 * Performs action concerning a ping request to this entity
+	 * @param ev the event object
+	 */
+	protected void processPingRequest(Sim_event ev) {
+        InfoPacket pkt = (InfoPacket) ev.get_data();
+        pkt.setTag(GridSimTags.INFOPKT_RETURN);
+        pkt.setDestID(pkt.getSrcID());
+
+		// sends back to the sender
+		send(output, GridSimTags.SCHEDULE_NOW, GridSimTags.INFOPKT_RETURN,
+				new IO_data(pkt, pkt.getSize(), pkt.getSrcID()));
+    }
+		
+	protected Job prepareJob(JobDescription jobDescription, long submissionTime){
+
+		Job newJob = new Job(jobDescription.getJobId());
+		DateTime submitionTime = new DateTime();
+        submitionTime = submitionTime.plusMillis((int)submissionTime*1000);
+			try {
+				
+				// transform job description to resource requirements
+
+				newJob.setSenderId(this.get_id());
+				
+				for (TaskDescription taskDescription : jobDescription) {
+					
+					String xmlResReq = this.xsltTransformer.taskToResourceRequirements(
+										taskDescription.getDocument(),
+										jobDescription.getJobId(),
+										taskDescription.getUserDn(),
+										submitionTime);
+
+					Task newTask = new Task(xmlResReq);
+					newTask.setSenderId(this.get_id());
+					newTask.setStatus((int)BrokerConstants.TASK_STATUS_UNSUBMITTED);
+					newTask.setLength(taskDescription.getTaskLength());
+					newTask.setWorkloadLogWaitTime(taskDescription.getWorkloadLogWaitTime());
+			//		newTask.setSubmissionTime(taskDescription.getSubmissionTime());
+					
+					newJob.add(newTask);
+				}
+
+				jobDescription.discardUnused();
+				
+			} catch (Exception e){
+				log.error(e.getMessage());
+				e.printStackTrace();
+			}
+		
+		return newJob;
+	}
+}
Index: /DCWoRMS/trunk/src/simulator/workload/generator/impl/QcgJobGenerator.java
===================================================================
--- /DCWoRMS/trunk/src/simulator/workload/generator/impl/QcgJobGenerator.java	(revision 477)
+++ /DCWoRMS/trunk/src/simulator/workload/generator/impl/QcgJobGenerator.java	(revision 481)
@@ -58,5 +58,5 @@
 import org.xml.sax.InputSource;
 
-import simulator.WormsConstants;
+import simulator.DCWormsConstants;
 import simulator.utils.GSSimXML;
 import simulator.utils.XsltTransformations;
@@ -259,5 +259,5 @@
 			
 			//initially - a standard value
-			taskCountToBeGenerated = WormsConstants.DEFAULT_TASK_COUNT_IN_SINGLE_JOB; 
+			taskCountToBeGenerated = DCWormsConstants.DEFAULT_TASK_COUNT_IN_SINGLE_JOB; 
 			
 			try {
Index: /DCWoRMS/trunk/src/schedframe/ExecutablesList.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/ExecutablesList.java	(revision 481)
+++ /DCWoRMS/trunk/src/schedframe/ExecutablesList.java	(revision 481)
@@ -0,0 +1,154 @@
+package schedframe;
+
+import gssim.schedframe.scheduling.ExecTask;
+import gssim.schedframe.scheduling.Executable;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.Iterator;
+import java.util.List;
+import java.util.ListIterator;
+
+public class ExecutablesList implements List<ExecTask> {
+
+	private List<ExecTask> executables;
+	public ExecutablesList (){
+		executables = Collections.synchronizedList(new ArrayList<ExecTask>());
+	}
+
+
+	public List<Executable> getJobExecutables(String jobId){
+		List<Executable> list = new ArrayList<Executable>();
+		synchronized (executables)  {
+			for(int i = 0; i < executables.size(); i++){
+				Executable exec = (Executable)executables.get(i);
+				
+				if(exec.getJobId().equals(jobId))
+					list.add(exec);
+			}
+		}
+		return list;
+	}
+	
+	public List<Executable> getTaskExecutables(String jobId, String taskId){
+		
+		List<Executable> list = new ArrayList<Executable>();
+		synchronized (executables)  {
+			for(int i = 0; i < executables.size(); i++){
+				Executable exec = (Executable)executables.get(i);
+				
+				if(exec.getJobId().equals(jobId) && exec.getId().equals(taskId))
+					list.add(exec);
+			}
+		}
+		return list;
+	}
+	
+	public Executable getTaskExecutable(Integer executableId){
+		synchronized (executables)  {
+			for (ExecTask task : executables) {
+				Executable exec = (Executable)task;
+				if (exec.getUniqueId() == executableId) {
+					return exec;
+				}
+			}
+		}
+		return null;
+	}
+	
+	
+	public boolean add(ExecTask arg0) {
+		return executables.add(arg0);
+	}
+
+	public void add(int arg0, ExecTask arg1) {
+		executables.add(arg0, arg1);
+	}
+
+	public boolean addAll(Collection<? extends ExecTask> arg0) {
+		return executables.addAll(arg0);
+	}
+
+	public boolean addAll(int arg0, Collection<? extends ExecTask> arg1) {
+		return executables.addAll(arg0, arg1);
+	}
+
+	public void clear() {
+		executables.clear();
+	}
+
+	public boolean contains(Object arg0) {
+		return executables.contains(arg0);
+	}
+
+	public boolean containsAll(Collection<?> arg0) {
+		return executables.containsAll(arg0);
+	}
+
+	public ExecTask get(int arg0) {
+		return executables.get(arg0);
+	}
+
+	public int indexOf(Object arg0) {
+		return indexOf(arg0);
+	}
+
+	public boolean isEmpty() {
+		return executables.isEmpty();
+	}
+
+	public Iterator<ExecTask> iterator() {
+		return executables.iterator();
+	}
+
+	public int lastIndexOf(Object arg0) {
+		return executables.lastIndexOf(arg0);
+	}
+
+	public ListIterator<ExecTask> listIterator() {
+		return executables.listIterator();
+	}
+
+	public ListIterator<ExecTask> listIterator(int arg0) {
+		return executables.listIterator(arg0);
+	}
+
+	public boolean remove(Object arg0) {
+		return executables.remove(arg0);
+	}
+
+	public ExecTask remove(int arg0) {
+		return executables.remove(arg0);
+	}
+
+	public boolean removeAll(Collection<?> arg0) {
+		return executables.removeAll(arg0);
+	}
+
+	public boolean retainAll(Collection<?> arg0) {
+		return executables.retainAll(arg0);
+	}
+
+	public ExecTask set(int arg0, ExecTask arg1) {
+		return executables.set(arg0, arg1);
+	}
+
+	public int size() {
+		return executables.size();
+	}
+
+	public List<ExecTask> subList(int arg0, int arg1) {
+		return executables.subList(arg0, arg1);
+	}
+
+	public Object[] toArray() {
+		return executables.toArray();
+	}
+
+	public <T> T[] toArray(T[] arg0) {
+		return executables.toArray(arg0);
+	}
+	
+}
+
Index: /DCWoRMS/trunk/src/schedframe/scheduling/Scheduler.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/Scheduler.java	(revision 478)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/Scheduler.java	(revision 481)
@@ -8,5 +8,5 @@
 import gridsim.GridSimTags;
 import gridsim.IO_data;
-import gridsim.gssim.WormsTags;
+import gridsim.gssim.DCWormsTags;
 
 import java.util.ArrayList;
@@ -28,6 +28,6 @@
 import schedframe.scheduling.manager.resources.ManagedResources;
 import schedframe.scheduling.policy.AbstractManagementSystem;
+import schedframe.scheduling.queue.QueueDescription;
 import schedframe.scheduling.queue.TaskQueue;
-import schedframe.scheduling.queue.QueueDescription;
 import schedframe.scheduling.tasks.WorkloadUnit;
 
@@ -117,5 +117,5 @@
 				if (obj != null) {
 					int delay = (Integer) obj;
-					send(this.get_id(), delay, WormsTags.TIMER);
+					send(this.get_id(), delay, DCWormsTags.TIMER);
 				}
 			}
@@ -174,5 +174,5 @@
 	protected void processOtherRequest(Sim_event ev) {
 		switch (ev.get_tag()) {
-		case WormsTags.QUERY_RESOURCE_DESC:
+		case DCWormsTags.QUERY_RESOURCE_DESC:
 			SchedulerDescription desc = new SchedulerDescription(new LocalSystem(get_name(), null, null));
 			Map<ResourceUnitName, List<ResourceUnit>> units = managementSystem.getResourceManager().getSharedResourceUnits();
@@ -181,5 +181,5 @@
 
 			IO_data data = new IO_data(desc, 0, ev.get_src());
-			send(ev.get_src(), GridSimTags.SCHEDULE_NOW, WormsTags.QUERY_RESOURCE_DESC_RESULT, data);
+			send(ev.get_src(), GridSimTags.SCHEDULE_NOW, DCWormsTags.QUERY_RESOURCE_DESC_RESULT, data);
 			break;
 
@@ -271,5 +271,5 @@
 	public List<QueueDescription> getQueuesDescription(){
 		List<QueueDescription> queues = new ArrayList<QueueDescription>();
-		for(TaskQueue queue: managementSystem.getAccessQueues()){
+		for(TaskQueue queue: managementSystem.getQueues()){
 			QueueDescription qd;
 			try {
Index: /DCWoRMS/trunk/src/schedframe/scheduling/plugin/SchedulingPlugin.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/plugin/SchedulingPlugin.java	(revision 477)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/plugin/SchedulingPlugin.java	(revision 481)
@@ -3,5 +3,5 @@
 import schedframe.Plugin;
 import schedframe.events.scheduling.SchedulingEvent;
-import schedframe.scheduling.WorkloadUnitListImpl;
+import schedframe.scheduling.TaskListImpl;
 import schedframe.scheduling.manager.resources.ResourceManager;
 import schedframe.scheduling.manager.tasks.JobRegistry;
@@ -12,5 +12,5 @@
 public interface SchedulingPlugin extends Plugin{
 
-	public int placeJobsInQueues(WorkloadUnitListImpl newJobs,
+	public int placeTasksInQueues(TaskListImpl newTasks,
 			TaskQueueList queues, 
 			ResourceManager resourceManager, ModuleList modules);
Index: /DCWoRMS/trunk/src/schedframe/scheduling/policy/AbstractManagementSystem.java
===================================================================
--- /DCWoRMS/trunk/src/schedframe/scheduling/policy/AbstractManagementSystem.java	(revision 480)
+++ /DCWoRMS/trunk/src/schedframe/scheduling/policy/AbstractManagementSystem.java	(revision 481)
@@ -10,5 +10,4 @@
 import schedframe.PluginConfiguration;
 import schedframe.events.scheduling.SchedulingEventType;
-import schedframe.resources.units.StandardResourceUnitName;
 import schedframe.scheduling.Scheduler;
 import schedframe.scheduling.WorkloadUnitHandler;
@@ -16,6 +15,6 @@
 import schedframe.scheduling.manager.resources.ResourceManager;
 import schedframe.scheduling.manager.resources.ResourceManagerFactory;
+import schedframe.scheduling.manager.tasks.JobRegistry;
 import schedframe.scheduling.manager.tasks.JobRegistryImpl;
-import schedframe.scheduling.manager.tasks.JobRegistry;
 import schedframe.scheduling.plan.AllocationInterface;
 import schedframe.scheduling.plan.SchedulingPlanInterface;
@@ -27,12 +26,12 @@
 import schedframe.scheduling.queue.TaskQueueList;
 import schedframe.scheduling.tasks.Job;
+import schedframe.scheduling.tasks.TaskInterface;
 import schedframe.scheduling.tasks.WorkloadUnit;
-import simulator.WormsConstants;
+import simulator.DCWormsConstants;
 import eduni.simjava.Sim_event;
 import gridsim.GridSim;
 import gridsim.GridSimTags;
-import gridsim.Gridlet;
 import gridsim.IO_data;
-import gridsim.gssim.WormsTags;
+import gridsim.gssim.DCWormsTags;
 import gssim.schedframe.scheduling.ExecTask;
 import gssim.schedframe.scheduling.Executable;
@@ -45,15 +44,13 @@
 	protected String name;
 
+	protected TaskQueueList queues;
 	protected ResourceManager resourceManager;
-
-	protected TaskQueueList queues;
-
+	protected JobRegistryImpl jobRegistry;
+	protected ModuleList moduleList;
+	
 	protected SchedulingPlugin schedulingPlugin;
-
 	protected ExecutionTimeEstimationPlugin execTimeEstimationPlugin;
 
-	protected ModuleList moduleList;
-	
-	protected JobRegistryImpl jobRegistry;
+	protected Scheduler scheduler;
 	
 
@@ -67,4 +64,17 @@
 	}
 	
+	public void init(Scheduler sched, ManagedResources managedResources) {
+		scheduler = sched;
+		resourceManager = ResourceManagerFactory.createResourceManager(scheduler, managedResources);
+		scheduler.set_stat(DCWormsConstants.getResourcesStatisticsObject(queues.size()));
+		for(int i = 0; i < queues.size(); i++){
+			TaskQueue q = queues.get(i);
+			if(q instanceof AbstractStatsSupportingQueue<?>){
+				AbstractStatsSupportingQueue<?> queue = (AbstractStatsSupportingQueue<?>) q;
+				queue.setStats(scheduler.get_stat(), DCWormsConstants.TASKS_QUEUE_LENGTH_MEASURE_NAME + "_" + Integer.toString(i));
+			}
+		}
+	}
+	
 	public void processEvent(Sim_event ev) {
 		processOtherEvent(ev);
@@ -81,10 +91,7 @@
 	}
 	
+	
 	public String getName() {
 		return name;
-	}
-
-	public PluginConfiguration getSchedulingPluginConfiguration() {
-		return schedulingPlugin.getConfiguration();
 	}
 	
@@ -106,4 +113,12 @@
 		return jobRegistry;
 	}
+	
+	public Scheduler getScheduler() {
+		return scheduler;
+	}
+	
+	public PluginConfiguration getSchedulingPluginConfiguration() {
+		return schedulingPlugin.getConfiguration();
+	}
 
 	public boolean pluginSupportsEvent(int eventType){
@@ -111,16 +126,18 @@
 	}
 
-	public abstract void notifySubmittedWorkloadUnit(WorkloadUnit wu, boolean ack);
-
-	public abstract void notifyCanceledWorkloadUnit(WorkloadUnit wu);
-
-	public abstract void notifyReturnedWorkloadUnit(WorkloadUnit wu);
-
-	protected abstract void executeSchedulingPlan(SchedulingPlanInterface decision);
-
-
-
+	public TaskQueueList getQueues(){
+		return queues;
+	}
+	
+	public Map<String, Integer> getQueuesSize() {
+		Map<String, Integer> queue_size = new HashMap<String, Integer>();
+		for (TaskQueue queue : queues) {
+			queue_size.put(queue.getName(), queue.size());
+		}
+		return queue_size;
+	}
+	
 	//POPRAWIC  (ale co? bo teraz chyba jest ok)
-	protected void submitWorkloadUnit(WorkloadUnit wu, AllocationInterface allocation) {
+	protected void submitTask(TaskInterface<?> task, AllocationInterface<?> allocation) {
 		String providerName = allocation.getProviderName();
 		if (providerName == null) {
@@ -128,38 +145,6 @@
 		}
 		//Executable exec = (Executable) wu;
-		removeFromQueue(wu);
-		scheduler.send(providerName, GridSimTags.SCHEDULE_NOW, GridSimTags.GRIDLET_SUBMIT, wu);	
-	}
-	
-	protected boolean sendCanceledWorkloadUnit(int tag, Executable task, int executableId, int destId) {
-		
-		if (tag != GridSimTags.GRIDLET_CANCEL) {
-			return false;
-		}
-
-		long taskSize = 0;
-		if (task != null) {
-			taskSize = task.getGridletOutputSize();
-		}
-
-		// if no Gridlet found, then create a new Gridlet but set its status
-		// to FAILED. Then, most importantly, set the resource parameters
-		// because the user will search/filter based on a resource ID.
-		else if (task == null) {
-			try {
-				taskSize = 100;
-				task = jobRegistry.getTaskExecutable(executableId);
-				task.setGridletStatus(Gridlet.FAILED);
-				int cost = resourceManager.getSharedResourceUnits().get(StandardResourceUnitName.COST) != null ? resourceManager
-						.getSharedResourceUnits().get(StandardResourceUnitName.COST).get(0).getAmount()
-						: 1;
-				task.setResourceParameter(scheduler.get_id(), cost);
-			} catch (Exception e) {
-				// empty ...
-			}
-		}
-		scheduler.send(scheduler.getOutputPort(), GridSimTags.SCHEDULE_NOW, tag,  new IO_data(task, taskSize, destId));
-
-		return true;
+		removeFromQueue(task);
+		scheduler.send(providerName, GridSimTags.SCHEDULE_NOW, GridSimTags.GRIDLET_SUBMIT, task);	
 	}
 
@@ -184,10 +169,4 @@
 
 	protected void sendExecutableReadyEvent(ExecTask exec) {
-
-		/*if (wu instanceof JobInterface) {
-			scheduler.sendInternal(Long.valueOf(0).doubleValue(), GssimTags.TASK_READY_FOR_EXECUTION,
-					wu);
-			return;
-		}*/
 
 		long delay = 0;
@@ -202,5 +181,5 @@
 		}
 
-		scheduler.sendInternal(Long.valueOf(delay).doubleValue(), WormsTags.TASK_READY_FOR_EXECUTION,
+		scheduler.sendInternal(Long.valueOf(delay).doubleValue(), DCWormsTags.TASK_READY_FOR_EXECUTION,
 				exec);
 	}
@@ -214,5 +193,5 @@
 				if (obj != null) {
 					int delay = (Integer) obj;
-					scheduler.sendInternal(delay, WormsTags.TIMER, null);
+					scheduler.sendInternal(delay, DCWormsTags.TIMER, null);
 				}
 			}
@@ -229,37 +208,12 @@
 		return false;
 	}
-
-	public TaskQueueList getAccessQueues(){
-		return queues;
-	}
-	
-	public Map<String, Integer> getQueuesSize() {
-		Map<String, Integer> queue_size = new HashMap<String, Integer>();
-		for (TaskQueue queue : queues) {
-			queue_size.put(queue.getName(), queue.size());
-		}
-		return queue_size;
-	}
-
-	public void init(Scheduler sched, ManagedResources managedResources) {
-		scheduler = sched;
-		resourceManager = ResourceManagerFactory.createResourceManager(scheduler, managedResources);
-		scheduler.set_stat(WormsConstants.getResourcesStatisticsObject(queues.size()));
-		for(int i = 0; i < queues.size(); i++){
-			TaskQueue q = queues.get(i);
-			if(q instanceof AbstractStatsSupportingQueue<?>){
-				AbstractStatsSupportingQueue<?> queue = (AbstractStatsSupportingQueue<?>) q;
-				queue.setStats(scheduler.get_stat(), WormsConstants.TASKS_QUEUE_LENGTH_MEASURE_NAME + "_" + Integer.toString(i));
-			}
-		}
-	}
-
-	protected Scheduler scheduler;
-
-	public Scheduler getScheduler() {
-		return scheduler;
-	}
 	
 	public abstract WorkloadUnitHandler getWorkloadUnitHandler();
+	
+	public abstract void notifySubmittedWorkloadUnit(WorkloadUnit wu, boolean ack);
+
+	public abstract void notifyReturnedWorkloadUnit(WorkloadUnit wu);
+
+	protected abstract void executeSchedulingPlan(SchedulingPlanInterface<?> decision);
 
 }
